Index: /orxonox/branches/gui/console/orxonox_console.cc
===================================================================
--- /orxonox/branches/gui/console/orxonox_console.cc	(revision 1892)
+++ /orxonox/branches/gui/console/orxonox_console.cc	(revision 1893)
@@ -31,5 +31,4 @@
 void OrxonoxConsole::createWindow ()
 {
-  //entry = new OrxonoxConsoleEntry(*log, entry);
   
   window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
Index: /orxonox/branches/gui/console/orxonox_console_entry.cc
===================================================================
--- /orxonox/branches/gui/console/orxonox_console_entry.cc	(revision 1892)
+++ /orxonox/branches/gui/console/orxonox_console_entry.cc	(revision 1893)
@@ -29,12 +29,12 @@
 
 
-/*
-OrxonoxConsoleEntry::OrxonoxConsoleEntry(OrxonoxConsoleLog* log, 
-					 OrxonoxConsoleEntry* test)
+OrxonoxConsoleEntry::OrxonoxConsoleEntry()
+{}
+
+OrxonoxConsoleEntry::OrxonoxConsoleEntry(OrxonoxConsoleLog* log)
 {
-  consoleLog = log;
+  consoleLog = log; 
+}
 
-}
-*/
 
 GtkWidget* OrxonoxConsoleEntry::createEntry()
Index: /orxonox/branches/gui/console/orxonox_console_entry.h
===================================================================
--- /orxonox/branches/gui/console/orxonox_console_entry.h	(revision 1892)
+++ /orxonox/branches/gui/console/orxonox_console_entry.h	(revision 1893)
@@ -25,5 +25,6 @@
 
  public:
-  //OrxonoxConsoleEntry(OrxonoxConsoleLog* log, OrxonoxConsoleEntry* test);
+  OrxonoxConsoleEntry(void);
+  OrxonoxConsoleEntry(OrxonoxConsoleLog* log);
   
   GtkWidget* createEntry(void);
Index: /orxonox/branches/gui/guicc/Makefile
===================================================================
--- /orxonox/branches/gui/guicc/Makefile	(revision 1893)
+++ /orxonox/branches/gui/guicc/Makefile	(revision 1893)
@@ -0,0 +1,78 @@
+
+CC = gcc
+CXX = g++
+APP_LIB_DEPS = `pkg-config --libs  gtk+-2.0`
+GL_LIB = libGL.so
+GLU_LIB = libGLU.so
+GLUT_LIB = libglut.so
+GLW_LIB = libGLw.so
+OSMESA_LIB = libOSMesa.so
+
+CFLAGS = `pkg-config --cflags gtk+-2.0`
+CXXFLAGS = -fPIC -O3
+GLUT_CFLAGS = -fexceptions
+
+TOP = ../..
+INCDIR = /usr/Mesa-6.0.1/include
+LIBDIR = /usr/Mesa-6.0.1/lib
+
+LIBS = -L$(LIBDIR) $(APP_LIB_DEPS)
+
+OSMESA_LIBS = -L$(LIBDIR) -lglut -lOSMesa -lGLU -lGL $(APP_LIB_DEPS)
+
+LIB_DEP = $(LIBDIR)/$(GL_LIB) $(LIBDIR)/$(GLU_LIB) $(LIBDIR)/$(GLUT_LIB)
+
+PROGS = \
+	orxonox_gui \
+
+HEADERS = \
+	orxonox_gui.h \
+
+
+SOURCES = \
+	orxonox_gui.cc \
+
+OBJECTS = \
+	orxonox_gui.o 
+#	orxonox_gui_exec.o \
+#	orxonox_gui_audio.o \
+#	orxonox_gui_video.o \
+#	orxonox_gui_file.o 
+
+TARGET = orxonox_gui
+
+.SUFFIXES:
+.SUFFIXES: .cc .o
+
+#.cc: $(LIB_DEP)
+#	$(CXX) -I$(INCDIR) $(CFLAGS) $< $(LIBS) -o $@
+
+.cc.o:
+	@ echo "$@ is being comiled..."
+	@ $(CXX) -c $(CFLAGS) -I$(INCDIR) -o $@ $<
+
+
+#### build
+
+all: $(TARGET)
+
+$(TARGET): $(OBJECTS)
+	@ echo "orxonox_gui is being linked..."
+	@ $(CXX) $(LIBS) -o $(TARGET) $(OBJECTS)
+
+
+help:
+	@echo "Cleaning targets:"
+	@echo "  clean		- remove most generated files"
+	@echo ""
+	@echo "Generic targets:"
+	@echo "  all		- Build all targets"
+	@echo ""
+	@echo "For further info see the README file"
+
+clean:
+	rm -rf *.o *~
+	rm $(TARGET)
+
+
+#EOF
Index: /orxonox/branches/gui/guicc/orxonox_gui.cc
===================================================================
--- /orxonox/branches/gui/guicc/orxonox_gui.cc	(revision 1893)
+++ /orxonox/branches/gui/guicc/orxonox_gui.cc	(revision 1893)
@@ -0,0 +1,53 @@
+#include "orxonox_gui.h"
+
+int main( int argc, char *argv[] )
+  {
+    gtk_init (&argc, &argv);
+    Window* orxonoxGUI = new Window("Graphical Orxonox Launcher");
+    orxonoxGUI->connectSignal (orxonoxGUI, "destroy", orxonox_gui_quit);
+    orxonoxGUI->show ();
+
+    gtk_main();
+    return 0;
+  }
+
+Window::Window (void)
+{
+  widget = gtk_window_new (GTK_WINDOW_TOPLEVEL);
+  gtk_window_set_policy(GTK_WINDOW(widget), TRUE, TRUE, TRUE);
+}
+
+Window::Window (char* windowName)
+{
+  widget = gtk_window_new (GTK_WINDOW_TOPLEVEL);
+  gtk_window_set_policy(GTK_WINDOW(widget), TRUE, TRUE, TRUE);
+  this->setTitle(windowName);
+  //  g_signal_connect (G_OBJECT (widget), "delete_event", G_CALLBACK (gtk_main_quit), NULL);
+  // g_signal_connect (G_OBJECT (widget), "destroy", G_CALLBACK (orxonox_gui_quit), orxonox_settings);
+  // gtk_container_set_border_width (GTK_CONTAINER (widget), 5);
+}
+
+Window::~Window ()
+{}
+
+void Window::show ()
+{
+  gtk_widget_show_all  (widget);
+}
+
+void Window::setTitle (char* title)
+{
+  gtk_window_set_title (GTK_WINDOW (widget), title);
+}
+
+void Widget::connectSignal (Widget* thisWidget, char* event, gint ( *signal)( GtkWidget*, GdkEvent*, void *))
+{
+  g_signal_connect (G_OBJECT (thisWidget->widget), event, G_CALLBACK (signal), NULL);
+}
+
+
+gint orxonox_gui_quit ( GtkWidget *widget, GdkEvent *event, gpointer data)
+{
+  gtk_main_quit();
+  return FALSE;
+}
Index: /orxonox/branches/gui/guicc/orxonox_gui.h
===================================================================
--- /orxonox/branches/gui/guicc/orxonox_gui.h	(revision 1893)
+++ /orxonox/branches/gui/guicc/orxonox_gui.h	(revision 1893)
@@ -0,0 +1,62 @@
+#ifndef _ORXONOX_GUI_H
+#define _ORXONOX_GUI_H
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <gtk/gtk.h>
+
+
+class Widget
+{
+ private:
+
+  Widget* next;
+  
+
+ public:
+  GtkWidget* widget;
+  //virtual void create ();
+  virtual void show () = 0;
+  //  void addWidget ();
+  static void connectSignal (Widget* thisWidget, char* event, gint (*signal)(GtkWidget*, GdkEvent*,  void *));
+};
+
+
+
+class Container : public Widget
+{
+ private:
+  int borderwidth;
+  int policy;
+  char* label;
+  Widget* down;
+  
+ public:
+  void setBorderWidth (int borderwidth);
+  virtual void setTitle (char* title) = 0;
+};
+
+class Window : public Container
+{
+ private:
+
+  
+
+ public:
+  Window (char* windowName);
+  Window (void);
+  ~Window ();
+  void setTitle (char* title);
+  void show ();
+
+};
+
+class Box : public Widget
+{
+
+};
+
+gint orxonox_gui_quit ( GtkWidget *widget, GdkEvent *event, gpointer data);
+
+#endif /* _ORXONOX_GUI_H */